Skip to content
Start here

User Schemas

Retrieve information about all schemas on a zone
Deprecated
client.apiGateway.userSchemas.list(UserSchemaListParams { zone_id, omit_source, page, 2 more } params, RequestOptionsoptions?): V4PagePaginationArray<OldPublicSchema { created_at, kind, name, 3 more } >
GET/zones/{zone_id}/api_gateway/user_schemas
Retrieve information about a specific schema on a zone
Deprecated
client.apiGateway.userSchemas.get(stringschemaId, UserSchemaGetParams { zone_id, omit_source } params, RequestOptionsoptions?): OldPublicSchema { created_at, kind, name, 3 more }
GET/zones/{zone_id}/api_gateway/user_schemas/{schema_id}
Upload a schema to a zone
Deprecated
client.apiGateway.userSchemas.create(UserSchemaCreateParams { zone_id, file, kind, 2 more } params, RequestOptionsoptions?): UserSchemaCreateResponse { schema, upload_details }
POST/zones/{zone_id}/api_gateway/user_schemas
Enable validation for a schema
Deprecated
client.apiGateway.userSchemas.edit(stringschemaId, UserSchemaEditParams { zone_id, validation_enabled } params, RequestOptionsoptions?): OldPublicSchema { created_at, kind, name, 3 more }
PATCH/zones/{zone_id}/api_gateway/user_schemas/{schema_id}
Delete a schema
Deprecated
client.apiGateway.userSchemas.delete(stringschemaId, UserSchemaDeleteParams { zone_id } params, RequestOptionsoptions?): UserSchemaDeleteResponse { errors, messages, success }
DELETE/zones/{zone_id}/api_gateway/user_schemas/{schema_id}
ModelsExpand Collapse
Message = Array<MessageItem>
code: number
minimum1000
message: string
documentation_url?: string
source?: Source { pointer }
pointer?: string
OldPublicSchema { created_at, kind, name, 3 more }
created_at: string
formatdate-time
kind: "openapi_v3"

Kind of schema

name: string

Name of the schema

schema_id: string

UUID.

maxLength36
minLength36
source?: string

Source of the schema

validation_enabled?: boolean

Flag whether schema is enabled for validation.

UserSchemaCreateResponse { schema, upload_details }
schema: OldPublicSchema { created_at, kind, name, 3 more }
upload_details?: UploadDetails { warnings }
warnings?: Array<Warning>

Diagnostic warning events that occurred during processing. These events are non-critical errors found within the schema.

code: number

Code that identifies the event that occurred.

locations?: Array<string>

JSONPath location(s) in the schema where these events were encountered. See https://goessner.net/articles/JsonPath/ for JSONPath specification.

message?: string

Diagnostic message that describes the event.

UserSchemaDeleteResponse { errors, messages, success }
errors: Message { code, message, documentation_url, source }
messages: Message { code, message, documentation_url, source }
success: true

Whether the API call was successful.

User SchemasOperations

Retrieve all operations from a schema.
Deprecated
client.apiGateway.userSchemas.operations.list(stringschemaId, OperationListParams { zone_id, endpoint, feature, 5 more } params, RequestOptionsoptions?): V4PagePaginationArray<OperationListResponse>
GET/zones/{zone_id}/api_gateway/user_schemas/{schema_id}/operations
ModelsExpand Collapse
OperationListResponse = APIShieldOperation { endpoint, host, last_updated, 3 more } | APIShieldBasicOperation { endpoint, host, method }
One of the following:
APIShieldOperation { endpoint, host, last_updated, 3 more }
endpoint: string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: https://developers.cloudflare.com/rules/normalization/how-it-works/.

formaturi-template
maxLength4096
host: string

RFC3986-compliant host.

formathostname
maxLength255
last_updated: string
formatdate-time
method: "GET" | "POST" | "HEAD" | 6 more

The HTTP method used to access the endpoint.

One of the following:
"GET"
"POST"
"HEAD"
"OPTIONS"
"PUT"
"DELETE"
"CONNECT"
"PATCH"
"TRACE"
operation_id: string

UUID.

maxLength36
minLength36
features?: APIShieldOperationFeatureThresholds { thresholds } | APIShieldOperationFeatureParameterSchemas { parameter_schemas } | APIShieldOperationFeatureAPIRouting { api_routing } | 2 more
One of the following:
APIShieldOperationFeatureThresholds { thresholds }
thresholds?: Thresholds { auth_id_tokens, data_points, last_updated, 6 more }
auth_id_tokens?: number

The total number of auth-ids seen across this calculation.

data_points?: number

The number of data points used for the threshold suggestion calculation.

last_updated?: string
formatdate-time
p50?: number

The p50 quantile of requests (in period_seconds).

p90?: number

The p90 quantile of requests (in period_seconds).

p99?: number

The p99 quantile of requests (in period_seconds).

period_seconds?: number

The period over which this threshold is suggested.

requests?: number

The estimated number of requests covered by these calculations.

suggested_threshold?: number

The suggested threshold in requests done by the same auth_id or period_seconds.

APIShieldOperationFeatureParameterSchemas { parameter_schemas }
parameter_schemas: ParameterSchemas { last_updated, parameter_schemas }
last_updated?: string
formatdate-time
parameter_schemas?: ParameterSchemas { parameters, responses }

An operation schema object containing a response.

parameters?: Array<unknown>

An array containing the learned parameter schemas.

responses?: unknown

An empty response object. This field is required to yield a valid operation schema.

APIShieldOperationFeatureAPIRouting { api_routing }
api_routing?: APIRouting { last_updated, route }

API Routing settings on endpoint.

last_updated?: string
formatdate-time
route?: string

Target route.

APIShieldOperationFeatureConfidenceIntervals { confidence_intervals }
confidence_intervals?: ConfidenceIntervals { last_updated, suggested_threshold }
last_updated?: string
formatdate-time
suggested_threshold?: SuggestedThreshold { confidence_intervals, mean }
confidence_intervals?: ConfidenceIntervals { p90, p95, p99 }
p90?: P90 { lower, upper }

Upper and lower bound for percentile estimate

lower?: number

Lower bound for percentile estimate

upper?: number

Upper bound for percentile estimate

p95?: P95 { lower, upper }

Upper and lower bound for percentile estimate

lower?: number

Lower bound for percentile estimate

upper?: number

Upper bound for percentile estimate

p99?: P99 { lower, upper }

Upper and lower bound for percentile estimate

lower?: number

Lower bound for percentile estimate

upper?: number

Upper bound for percentile estimate

mean?: number

Suggested threshold.

APIShieldOperationFeatureSchemaInfo { schema_info }
schema_info?: SchemaInfo { active_schema, learned_available, mitigation_action }
active_schema?: ActiveSchema { id, created_at, is_learned, name }

Schema active on endpoint.

id?: string

UUID.

maxLength36
minLength36
created_at?: string
formatdate-time
is_learned?: boolean

True if schema is Cloudflare-provided.

name?: string

Schema file name.

learned_available?: boolean

True if a Cloudflare-provided learned schema is available for this endpoint.

mitigation_action?: "none" | "log" | "block" | null

Action taken on requests failing validation.

One of the following:
"none"
"log"
"block"
APIShieldBasicOperation { endpoint, host, method }
endpoint: string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: https://developers.cloudflare.com/rules/normalization/how-it-works/.

formaturi-template
maxLength4096
host: string

RFC3986-compliant host.

formathostname
maxLength255
method: "GET" | "POST" | "HEAD" | 6 more

The HTTP method used to access the endpoint.

One of the following:
"GET"
"POST"
"HEAD"
"OPTIONS"
"PUT"
"DELETE"
"CONNECT"
"PATCH"
"TRACE"

User SchemasHosts

Retrieve schema hosts in a zone
Deprecated
client.apiGateway.userSchemas.hosts.list(HostListParams { zone_id, page, per_page } params, RequestOptionsoptions?): V4PagePaginationArray<HostListResponse { created_at, hosts, name, schema_id } >
GET/zones/{zone_id}/api_gateway/user_schemas/hosts
ModelsExpand Collapse
HostListResponse { created_at, hosts, name, schema_id }
created_at: string
formatdate-time
hosts: Array<string>

Hosts serving the schema, e.g zone.host.com

name: string

Name of the schema

schema_id: string

UUID.

maxLength36
minLength36